bl_info = {
    "name" : "LIGHTNING Draw Addon",
    "author" : "CG", 
    "description" : "LIGHTNING Draw stands out as a particularly electrifying tool. This free Blender addon simplifies the process of creating procedural lightning effects, enabling artists to generate photorealistic lightning with ease.",
    "blender" : (3, 1, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "waring" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews

import os


def string_to_int(value):
    if value.isdigit():
        return int(value)
    return 0

def string_to_icon(value):
    if value in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items.keys():
        return bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items[value].value
    return string_to_int(value)
    
def icon_to_string(value):
    for icon in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items:
        if icon.value == value:
            return icon.name
    return "NONE"
    
def enum_set_to_string(value):
    if type(value) == set:
        if len(value) > 0:
            return "[" + (", ").join(list(value)) + "]"
        return "[]"
    return value
    
def string_to_type(value, to_type, default):
    try:
        value = to_type(value)
    except:
        value = default
    return value

addon_keymaps = {}
_icons = None
lightning_draw_addon = {}



class SNA_OT_Operator_3E6D5(bpy.types.Operator):
    bl_idname = "sna.operator_3e6d5"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    
    
    @classmethod
    def poll(cls, context):
        return not False
    def execute(self, context):
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'LIGHTNING Draw.blend') + r'\NodeTree', filename='LIGHTNING Draw', link=False)
        bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='NODES')
        bpy.context.active_object.modifiers.active.node_group = bpy.data.node_groups['LIGHTNING Draw']
        return {"FINISHED"}
    
    def invoke(self, context, event):
        
        
        return self.execute(context)
class SNA_PT_LIGHTNING_DRAW__21D78(bpy.types.Panel):
    bl_label = 'LIGHTNING Draw '
    bl_idname = 'SNA_PT_LIGHTNING_DRAW__21D78'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'LD'
    bl_order = 0
    
    
    @classmethod
    def poll(cls, context):
        return not (False)
    
    def draw_header(self, context):
        layout = self.layout
        
    def draw(self, context):
        layout = self.layout
        op = layout.operator('curve.primitive_bezier_curve_add', text='add curve', icon_value=0, emboss=True, depress=False)
        op = layout.operator('sna.operator_3e6d5', text='Convert Curve To LIGHTNING', icon_value=0, emboss=True, depress=False)
        layout.prop(bpy.data.scenes['Scene'].eevee, 'use_bloom', text='Bloom', icon_value=239, emboss=True)
        layout.prop(bpy.data.materials['LIGHTNING Pro '].node_tree.nodes['Principled BSDF'].inputs[19], 'default_value', text='LIGHTNING Color', icon_value=239, emboss=True)
        layout.prop(bpy.data.materials['LIGHTNING Pro '].node_tree.nodes['Principled BSDF'].inputs[20], 'default_value', text='Emission Strength', icon_value=239, emboss=True)



def register():
    
    global _icons
    _icons = bpy.utils.previews.new()
    
    
    bpy.utils.register_class(SNA_OT_Operator_3E6D5)
    bpy.utils.register_class(SNA_PT_LIGHTNING_DRAW__21D78)

def unregister():
    
    global _icons
    bpy.utils.previews.remove(_icons)
    
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    
    
    bpy.utils.unregister_class(SNA_OT_Operator_3E6D5)
    bpy.utils.unregister_class(SNA_PT_LIGHTNING_DRAW__21D78)

